var PageIndex = function() {
	//dom элементы
	this.el_content = document.getElementById('page_index');
	this.el_btn_left = document.getElementById('page_index_left_btn');
	this.el_btn_right = document.getElementById('page_index_right_btn');
	this.el_promo_center = document.getElementById('page_index_center_promo');
	this.el_promos = document.getElementById('page_index_promos');
	this.el_projects = document.getElementById('page_index_projects');
	
	this.promo_index = 0;
	this.promos = [];
	this.project_index = 0;
	this.projects = [];
	this.loading = false;
};

PageIndex.prototype.show = function() {
	show('main_preloader');
	show(this.el_content);

	widgetAPI.putInnerHTML(this.el_projects, '');
	widgetAPI.putInnerHTML(this.el_promos, '');

	this.loading = 2;
	var _this = this;
	Data.getPromos(function(promos) {
		_this.promos = promos;
		_this.loading--;
		if (!_this.loading) _this.showAfterload();
	});
	Data.getProjects(0, function(projects) {
		_this.projects = projects;
		_this.loading--;
		if (!_this.loading) _this.showAfterload();
	});
	
	onAnyKey = function(key) {
		return ! ((key == tvKey.VK_LEFT || key == tvKey.VK_RIGHT) && animated);
	};
};

PageIndex.prototype.showAfterload = function() {
	buttons.clear(10);
	this.showPromos();
	this.showProjects();
	hide('main_preloader');
	animated = false;
};

PageIndex.prototype.showPromos = function() {
	this.promo_index = 0;
	animateInitX(this.el_promos, SIZES.promo.left, 0.7);
	this.renderPromos();
	
	var _this = this;
	buttons.set(10, this.el_btn_left, [1,11,null,null, true], function() {
		animateX(_this.el_promos, SIZES.promo.left-(_this.promo_index-1)*SIZES.promo.width,  function() {
			_this.promo_index -= 1;
			_this.renderPromos();
		});
	});
	buttons.set(11, this.el_promo_center, [3,12,null,10, true], function(){
		var k = _this.promo_index % _this.promos.length;
		if (k<0) k = _this.promos.length + k;
		if (_this.promos[k].project_id) showPage('project', _this.promos[k].project_id);
	});
	buttons.set(12, this.el_btn_right, [4,null,null,11, true], function() {
		animateX(_this.el_promos, SIZES.promo.left-(_this.promo_index+1)*SIZES.promo.width,  function() {
			_this.promo_index += 1;
			_this.renderPromos();
		});
	});
	
	for (var i=1; i<8; i++) buttons[i].down = 11;
};

PageIndex.prototype.renderPromos = function() {
	var html = '';
	if (this.promos.length > 0) {
		for (var i = this.promo_index-2; i <= this.promo_index+2; i++) {
			var k = i % this.promos.length;
			if (k < 0) k = this.promos.length + k;
			html += '<div class="promo-item" style="left:'+(i*SIZES.promo.width)+'px"><img src="'+this.promos[k].medium_picture_url+'" width="'+SIZES.promo.img_width+'" height="'+SIZES.promo.img_height+'"></div>';
		}
	}
	html += '<div class="clear"></div>';
	widgetAPI.putInnerHTML(this.el_promos, html);
};

PageIndex.prototype.showProjects = function() {
	this.project_index = Math.floor((this.projects.length-1)/2); //середина
	animateInitX(this.el_projects, SIZES.popular_projects.left-this.project_index*SIZES.popular_projects.width, 0.8);
	this.renderProjects();
	
	var _this = this;
	var moved = true;
	this.el_projects.onmouseout = function(event) {
		if (!moved) moved = true;
	};
	
	function fn_click(btn) {
		var delta = btn.k-14;
		showPage('project', _this.projects[_this.project_index + delta].id);
	}
	function fn_move(btn) {
		if (!animated && !moved) moved = true;
		if (!animated && buttons.hover_btn != btn) {
			btn.el.onmouseover();
		}
	}
	function fn_hover(btn) {
		if (animated) return;
		var delta = btn.k-14;
		if (_this.project_index == 0) delta = delta+1;
                if ((_this.project_index == 1 && delta < 0) || (_this.project_index == _this.projects.length-2  && delta > 0)) return;
		if (delta != 0) {
			buttons.clear(13);
			_this.project_index += delta;
			_this.renderProjects();
			_this.setProjectsBtns(fn_click, fn_hover, fn_move);
			if (_this.project_index > 0) {
				buttons.hover_btn = buttons[14];
			} else {
				buttons.hover_btn = buttons[13];
			}
			addClass(buttons.hover_btn.el, 'hover');

			moved = false;
			animateX(_this.el_projects, SIZES.popular_projects.left-(_this.project_index)*SIZES.popular_projects.width, function() {
				if (!moved && window.NetCastGetMouseOnOff && window.NetCastGetMouseOnOff() == 'on') {
					setTimeout(function() {
						if (!moved && !animated) {
							moved = true;
							if (delta == 1 && buttons[15]) fn_hover(buttons[15]);
							if (delta == -1 && _this.projects.length > 2 && _this.project_index != 0) fn_hover(buttons[13]);
						}
					}, 300);					
				}
			});
		}
	}
	
	if (this.projects.length > 0) this.setProjectsBtns(fn_click, fn_hover, fn_move);
	if (this.projects.length == 0) {
		buttons[10].down = buttons[11].down = buttons[12].down = null;
	} else if (this.projects.length < 3) {
		buttons[10].down = buttons[11].down = buttons[12].down = 13;
	} else {
		buttons[10].down = buttons[11].down = buttons[12].down = 14;
	}
};

PageIndex.prototype.renderProjects = function() {
	var html = '';
	var from = (this.project_index - 3 >= 0) ? this.project_index - 3 : 0;
	var to = (this.project_index + 3 < this.projects.length) ? this.project_index + 3 : this.projects.length - 1;
	for (var i=from; i <= to; i++) {
		html += '<div class="video-item" id="page_index_project_'+i+'"'+((i == from) ? ' style="margin-left: '+(18+from*SIZES.popular_projects.width)+'px"' : '')+'>';
		if (this.projects[i].recent) html += '<div class="bul"><div class="bul-l"></div><div class="bul-c">'+this.projects[i].recent+'</div><div class="bul-r"></div><div class="clear"></div></div>';
		html += '<center><img src="'+this.projects[i].normal_thumbnail+'" width="'+SIZES.popular_projects.img_width+'" height="'+SIZES.popular_projects.img_height+'"><br>'+this.projects[i].title+'</center></div>';
	}
	this.el_projects.style.width = this.projects.length*(SIZES.popular_projects.width+1)+'px';
	widgetAPI.putInnerHTML(this.el_projects, html);
};

PageIndex.prototype.setProjectsBtns = function(click_callback, hover_callback, move_callback) {
	var els = [];
	if (this.project_index > 0) els.push('page_index_project_'+(this.project_index-1));
	els.push('page_index_project_'+this.project_index);
	if (this.project_index < this.projects.length-1) els.push('page_index_project_'+(this.project_index+1));
	
	buttons.setGroup(13, els, '1x3', true, click_callback, hover_callback);
	buttons[13].up=11;
	if (buttons[14]) buttons[14].up=11;
	if (buttons[15]) buttons[15].up=11;
	
	buttons[13].el.onmousemove = function() {move_callback(buttons[13]);};
	if (buttons[14]) buttons[14].el.onmousemove = function() {move_callback(buttons[14]);};
	if (buttons[15]) buttons[15].el.onmousemove = function() {move_callback(buttons[15]);};
};

PageIndex.prototype.hide = function() {
	onAnyKey = null;
	hide(this.el_content);
	hide('player_loader');
	hide('player_error');
};
